property audio_out_menu_item : %d
property audio_in_menu_item : %d
property delayTime : %f

global OS_version

UIscript_check()
switch_audio(audio_in_menu_item, audio_out_menu_item)

on switch_audio(audio_in, audio_out)
	try
		tell application "Skype"
			activate
		end tell
		openPrefs()
		if the OS_version is less than "1040" then
			switch_audio_ten3(audio_out, audio_in)
		else
			switch_audio_ten4(audio_out, audio_in)
		end if
		closePrefs()
		return true
	on error error_message number errNum
		display dialog error_message & " Error number: " & (errNum as string)
		return false
	end try
end switch_audio

on openPrefs()
	try
		tell application "System Events"
			tell process "Skype"
				set frontmost to true
				delay delayTime
				keystroke "," using command down
				delay delayTime
			end tell
		end tell
		return true
	on error error_message number errNum
		display dialog error_message & " Error number: " & (errNum as string)
		return false
	end try
end openPrefs

on closePrefs()
	try
		tell application "System Events"
			tell window "Audio" of front process
				keystroke "w" using command down
			end tell
		end tell
		return true
	on error error_message number errNum
		display dialog error_message & " Error number: " & (errNum as string)
		return false
	end try
end closePrefs

on switch_audio_ten3(audio_out, audio_in)
	try
		tell application "System Events"
			tell process "Skype"
				repeat audio_out + 1 times
					keystroke (ASCII character 31)
				end repeat
				keystroke return
				delay delayTime
				-- now the next pop up button
				keystroke tab
				repeat audio_in + 1 times
					keystroke (ASCII character 31)
				end repeat
				keystroke return
				delay delayTime
			end tell
		end tell
		return true
	on error error_message number errNum
		display dialog "Script failed: probably due to the delay time preference setting or menu items that are out of range. " & error_message & " Error number: " & (errNum as string)
		return false
	end try
end switch_audio_ten3

on switch_audio_ten4(select_item1, select_item2)
	try
		tell application "System Events"
			tell process "Skype"
				click button "Audio" of tool bar of front window
				delay delayTime
				tell group 1 of group 1 of window "Audio"
					click first pop up button
					delay delayTime
					click menu item select_item1 of menu of first pop up button
					delay delayTime
					click second pop up button
					delay delayTime
					click menu item select_item2 of menu of second pop up button
					delay delayTime
				end tell
			end tell
		end tell
		return true
	on error error_message number errNum
		display dialog "Script failed: probably due to the delay time preference setting or menu items that are out of range. " & error_message & " Error number: " & (errNum as string)
		return false
	end try
end switch_audio_ten4

on UIscript_check()
	-- get the system version
	set the hexData to system attribute "sysv"
	set hexString to {}
	repeat 4 times
		set hexString to ((hexData mod 16) as string) & hexString
		set hexData to hexData div 16
	end repeat
	set the OS_version to the hexString as string
	if the OS_version is less than "1030" then
		display dialog "This script requires the installation of " & 
			"Mac OS X 10.3 or higher." buttons {"Cancel"} 
			default button 1 with icon 2
	end if
	-- check to see if assistive devices is enabled
	tell application "System Events"
		set UI_enabled to UI elements enabled
		if UI_enabled is false then
			set the dialog_message to "This script utilizes " & 
				"the built-in Graphic User Interface Scripting " & 
				"architecture of Mac OS X " & 
				"which is currently disabled." & return & return & 
				"You can activate GUI Scripting by selecting the " & 
				"checkbox Enable access for assistive devices " & 
				"in the Universal Access preference pane."
			display dialog dialog_message buttons {"Cancel"} 
				default button 1 with icon 1
		end if
	end tell
end UIscript_check

